#include <Xm/MainW.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/TextF.h>
#include <Xm/PushB.h>
#include <stdlib.h>
#include <stdio.h>

#define c_Add 0
#define c_Subtract 1
#define c_Multiply 2
#define c_Divide 3

#define c_Text_operand_1  0
#define c_Text_operand_2  1

Widget operands [2]; 

/* Exit Callback */

static void Exit_Application (Widget w, XtPointer tag,
                              XmAnyCallbackStruct *reason)
{
  exit(1);
}

/* Berechnungs-Callback */

static void Compute (Widget w, int tag,
                     XmAnyCallbackStruct *reason)
{
  int op1, op2, result;
  char *buff = (char *)malloc(20);

  op1 = atoi(XmTextFieldGetString(operands[c_Text_operand_1]));
  op2 = atoi(XmTextFieldGetString(operands[c_Text_operand_2]));
  
  switch(tag) {
    case c_Add:      result = op1 + op2; break;
    case c_Subtract: result = op1 - op2; break;
    case c_Multiply: result = op1 * op2; break;
    case c_Divide:   if(op2)
                       result = op1 / op2;
		     else
		       result = 0; /* Nur um Fehler zu vermeiden */
		     break;
  }
  
  sprintf(buff,"%d",result);
  XmTextFieldSetString(operands[c_Text_operand_1],buff);
  XmTextFieldSetString(operands[c_Text_operand_2],"0");
}

/* Main */

unsigned int main (int argc, char **argv)
{
  XtAppContext app_context;
  
  Widget toplevel, main_window, main_form, button_form, text_form,
         label_operand_1, label_operand_2,
	 exit_button, add_button, sub_button, mul_button, div_button;

  XmString operand_1, operand_2, button_text;

  XtCallbackRec callbacks[2];

  Arg args[13];
  unsigned int count;

  /* X11 initialisieren, Shell-Widget erzeugen */

  toplevel = XtAppInitialize(&app_context,"Example",NULL,0,
                             &argc,argv,NULL,NULL,0);

  /* Main window erzeugen */

  main_window = XmCreateMainWindow(toplevel,"Main_Window",NULL,0);

  /* "Main Form" erzeugen */
  
  count = 0;
  XtSetArg(args[count],XmNborderWidth,0); count++;
  main_form = XmCreateForm(main_window,"Main_Form",args,count);
  XtManageChild(main_form);

  /* Form-Widgets fuer Textfelder erzeugen */

  count = 0;
  XtSetArg(args[count],XmNborderWidth,0); count++;
  XtSetArg(args[count],XmNshadowType,XmSHADOW_OUT); count++;
  XtSetArg(args[count],XmNshadowThickness,3); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNrightAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNrightOffset,5); count++;
  text_form = XmCreateForm(main_form,"Text_Form",args,count);
  XtManageChild(text_form);

  /* Label-Widget "Operand #1/Output" erzeugen */

  count = 0;
  operand_1 = XmStringCreateLtoR("Operand #1/Output:",XmSTRING_ISO8859_1);

  XtSetArg(args[count],XmNlabelString,operand_1); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNtopOffset,5); count++;
  label_operand_1 = XmCreateLabel(text_form,"Operand_1_Label",args,count);
  XtManageChild(label_operand_1);
  
  XmStringFree(operand_1);

  /* Text-Widget "Operand #1/Output" erzeugen */

  count = 0;
  XtSetArg(args[count],XmNvalue,"0"); count++;
  XtSetArg(args[count],XmNcolumns,20); count++;
  XtSetArg(args[count],XmNmaxLength,20); count++;
  XtSetArg(args[count],XmNresizable,0); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNrightAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNrightOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNtopWidget,label_operand_1); count++;
  XtSetArg(args[count],XmNtopOffset,1); count++;
  operands[c_Text_operand_1] = XmCreateTextField(text_form,"Operand_1_Text",
                                                 args,count);
  XtManageChild(operands[c_Text_operand_1]);

  /* Label-Widget "Operand #2" erzeugen */

  count = 0;
  operand_2 = XmStringCreateLtoR("Operand #2:",XmSTRING_ISO8859_1);

  XtSetArg(args[count],XmNlabelString,operand_2); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNtopWidget,operands[c_Text_operand_1]); count++;
  XtSetArg(args[count],XmNtopOffset,5); count++;
  label_operand_2 = XmCreateLabel(text_form,"Operand_2_Label",args,count);
  XtManageChild(label_operand_2);

  XmStringFree(operand_2);

  /* Text-Widget "Operand #2" erzeugen */

  count = 0;
  XtSetArg(args[count],XmNvalue,"0"); count++;
  XtSetArg(args[count],XmNcolumns,20); count++;
  XtSetArg(args[count],XmNmaxLength,20); count++;
  XtSetArg(args[count],XmNresizable,0); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNrightAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNrightOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNtopWidget,label_operand_2); count++;
  XtSetArg(args[count],XmNtopOffset,1); count++;
  XtSetArg(args[count],XmNbottomAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNbottomOffset,5); count++;
  operands[c_Text_operand_2]= XmCreateTextField(text_form,"Operand_2_Text",
                                                args,count);
  XtManageChild(operands[c_Text_operand_2]);

  /* Form-Widget fuer Push Buttons erzeugen */
   
  count = 0;
  XtSetArg(args[count],XmNborderWidth,0); count++;
  XtSetArg(args[count],XmNshadowType,XmSHADOW_IN); count++;
  XtSetArg(args[count],XmNshadowThickness,3); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNrightAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNrightOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNtopWidget,text_form); count++;
  XtSetArg(args[count],XmNtopOffset,5); count++;
  XtSetArg(args[count],XmNbottomAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNbottomOffset,5); count++;
  button_form = XmCreateForm(main_form,"Button_Form",args,count);
  XtManageChild(button_form);

  /* "Exit"-Button erzeugen */

  count = 0;
  button_text = XmStringCreateLtoR("Exit",XmSTRING_ISO8859_1);
  
  callbacks[0].callback = (XtCallbackProc)Exit_Application;
  callbacks[0].closure = NULL;
  callbacks[1].callback = NULL;
  callbacks[1].closure = NULL;

  XtSetArg(args[count],XmNlabelString,button_text); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNrightAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNrightOffset,5); count++;
  XtSetArg(args[count],XmNbottomAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNbottomOffset,5); count++;
  XtSetArg(args[count],XmNactivateCallback,callbacks); count++;
  exit_button = XmCreatePushButton(button_form,"Exit_Button",args,count);
  XtManageChild(exit_button);

  XmStringFree(button_text);
  
  /* Operator-Buttons erzeugen */

  count = 0;
  button_text = XmStringCreateLtoR("Add",XmSTRING_ISO8859_1);

  callbacks[0].callback = (XtCallbackProc)Compute;
  callbacks[0].closure = (XtPointer)c_Add;
  callbacks[1].callback = NULL;
  callbacks[1].closure = NULL;

  XtSetArg(args[count],XmNlabelString,button_text); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNtopOffset,5); count++;
  XtSetArg(args[count],XmNbottomAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNbottomWidget,exit_button); count++;
  XtSetArg(args[count],XmNbottomOffset,5); count++;
  XtSetArg(args[count],XmNactivateCallback,callbacks); count++;
  add_button = XmCreatePushButton(button_form,"Add_Button",args,count);
  XtManageChild(add_button);

  XmStringFree(button_text);

  count = 0;
  button_text = XmStringCreateLtoR("Subtract",XmSTRING_ISO8859_1);

  callbacks[0].closure = (XtPointer)c_Subtract;

  XtSetArg(args[count],XmNlabelString,button_text); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNleftWidget,add_button); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNtopOffset,5); count++;
  XtSetArg(args[count],XmNbottomAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNbottomWidget,exit_button); count++;
  XtSetArg(args[count],XmNbottomOffset,5); count++;
  XtSetArg(args[count],XmNactivateCallback,callbacks); count++;
  sub_button = XmCreatePushButton(button_form,"Sub_Button",args,count);
  XtManageChild(sub_button);

  XmStringFree(button_text);

  count = 0;
  button_text = XmStringCreateLtoR("Multiply",XmSTRING_ISO8859_1);

  callbacks[0].closure = (XtPointer)c_Multiply;
  
  XtSetArg(args[count],XmNlabelString,button_text); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNleftWidget,sub_button); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNtopOffset,5); count++;
  XtSetArg(args[count],XmNbottomAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNbottomWidget,exit_button); count++;
  XtSetArg(args[count],XmNbottomOffset,5); count++;
  XtSetArg(args[count],XmNactivateCallback,callbacks); count++;
  mul_button = XmCreatePushButton(button_form,"Mul_Button",args,count);
  XtManageChild(mul_button);

  XmStringFree(button_text);

  count = 0;
  button_text = XmStringCreateLtoR("Divide",XmSTRING_ISO8859_1);

  callbacks[0].closure = (XtPointer)c_Divide;
  
  XtSetArg(args[count],XmNlabelString,button_text); count++;
  XtSetArg(args[count],XmNleftAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNleftWidget,mul_button); count++;
  XtSetArg(args[count],XmNleftOffset,5); count++;
  XtSetArg(args[count],XmNrightAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNrightOffset,5); count++;
  XtSetArg(args[count],XmNtopAttachment,XmATTACH_FORM); count++;
  XtSetArg(args[count],XmNtopOffset,5); count++;
  XtSetArg(args[count],XmNbottomAttachment,XmATTACH_WIDGET); count++;
  XtSetArg(args[count],XmNbottomWidget,exit_button); count++;
  XtSetArg(args[count],XmNbottomOffset,5); count++;
  XtSetArg(args[count],XmNactivateCallback,callbacks); count++;
  div_button = XmCreatePushButton(button_form,"Div_Button",args,count);
  XtManageChild(div_button);

  XmStringFree(button_text);

  /* Ende der Widget-Generierung */

  XtManageChild(main_window);

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_context);
}
